/*!
 *  @preserve
 *  
 *  @module      iframe-resizer/child 5.4.7 (umd) - 2025-07-08
 *
 *  @license     GPL-3.0 for non-commercial use only.
 *               For commercial use, you must purchase a license from
 *               https://iframe-resizer.com/pricing
 * 
 *  @description Keep same and cross domain iFrames sized to their content 
 *
 *  @author      David J. Bradshaw <info@iframe-resizer.com>
 * 
 *  @see         {@link https://iframe-resizer.com}
 * 
 *  @copyright  (c) 2013 - 2025, David J. Bradshaw. All rights reserved.
 */


!function(e){"function"==typeof define&&define.amd?define(e):e()}((function(){"use strict";const e="font-weight: normal;",t="font-weight: bold;",n="font-style: italic;",o=e+n,r="default",i=Object.freeze({assert:!0,error:!0,warn:!0}),a={expand:!0,defaultEvent:void 0,event:void 0,label:"AutoConsoleGroup",showTime:!0},s={profile:0,profileEnd:0,timeStamp:0,trace:0},l=Object.assign(console);const{fromEntries:c,keys:u}=Object,d=e=>[e,l[e]],f=e=>t=>[t,function(n){e[t]=n}],m=(e,t)=>c(u(e).map(t));const p=!(typeof window>"u"||"function"!=typeof window.matchMedia)&&window.matchMedia("(prefers-color-scheme: dark)").matches,h=p?"color: #A9C7FB;":"color: #135CD2;",g=p?"color: #E3E3E3;":"color: #1F1F1F;",y="5.4.7",b=10,v="data-iframe-size",z="data-iframe-overflowed",w="data-iframe-ignore",$="bottom",S="right",E="autoResizeEnabled",O=Symbol("sizeChanged"),j="manualResize",k="parentResize",M={[j]:1,[k]:1},T="setOffsetSize",C="resizeObserver",x="overflowObserver",A="mutationObserver",I="none",P="init",N=(e,t,n,o)=>e.addEventListener(t,n,o||!1),R=["<iy><yi>Puchspk Spjluzl Rlf</><iy><iy>","<iy><yi>Tpzzpun Spjluzl Rlf</><iy><iy>","Aopz spiyhyf pz hchpshisl dpao ivao Jvttlyjphs huk Vwlu-Zvbyjl spjluzlz.<iy><iy><i>Jvttlyjphs Spjluzl</><iy>Mvy jvttlyjphs bzl, <p>pmyhtl-ylzpgly</> ylxbpylz h svd jvza vul aptl spjluzl mll. Mvy tvyl pumvythapvu cpzpa <b>oaawz://pmyhtl-ylzpgly.jvt/wypjpun</>.<iy><iy><i>Vwlu Zvbyjl Spjluzl</><iy>Pm fvb hyl bzpun aopz spiyhyf pu h uvu-jvttlyjphs vwlu zvbyjl wyvqlja aolu fvb jhu bzl pa mvy myll bukly aol alytz vm aol NWS C3 Spjluzl. Av jvumpyt fvb hjjlwa aolzl alytz, wslhzl zla aol <i>spjluzl</> rlf pu <p>pmyhtl-ylzpgly</> vwapvuz av <i>NWSc3</>.<iy><iy>Mvy tvyl pumvythapvu wslhzl zll: <b>oaawz://pmyhtl-ylzpgly.jvt/nws</>","<i>NWSc3 Spjluzl Clyzpvu</><iy><iy>Aopz clyzpvu vm <p>pmyhtl-ylzpgly</> pz ilpun bzlk bukly aol alytz vm aol <i>NWS C3</> spjluzl. Aopz spjluzl hssvdz fvb av bzl <p>pmyhtl-ylzpgly</> pu Vwlu Zvbyjl wyvqljaz, iba pa ylxbpylz fvby wyvqlja av il wbispj, wyvcpkl haaypibapvu huk il spjluzlk bukly clyzpvu 3 vy shaly vm aol NUB Nlulyhs Wbispj Spjluzl.<iy><iy>Pm fvb hyl bzpun aopz spiyhyf pu h uvu-vwlu zvbyjl wyvqlja vy dlizpal, fvb dpss ullk av wbyjohzl h svd jvza vul aptl jvttlyjphs spjluzl.<iy><iy>Mvy tvyl pumvythapvu cpzpa <b>oaawz://pmyhtl-ylzpgly.jvt/wypjpun</>.","<iy><yi>Zvsv spjluzl kvlz uva zbwwvya jyvzz-kvthpu</><iy><iy>Av bzl <p>pmyhtl-ylzpgly</> dpao jyvzz kvthpu pmyhtlz fvb ullk lpaoly aol Wyvmlzzpvuhs vy Ibzpulzz spjluzlz. Mvy klahpsz vu bwnyhkl wypjpun wslhzl jvuahja pumv@pmyhtl-ylzpgly.jvt."];Object.fromEntries(["2cgs7fdf4xb","1c9ctcccr4z","1q2pc4eebgb","ueokt0969w","w2zxchhgqz","1umuxblj2e5"].map(((e,t)=>[e,Math.max(0,t-1)])));const B=e=>(e=>e.replace(/[A-Za-z]/g,(e=>String.fromCodePoint((e<="Z"?90:122)>=(e=e.codePointAt(0)+19)?e:e-26))))(R[e]),q=(e,...t)=>setTimeout((()=>e(...t)),0),L=e=>{let t=!1;return function(){return t?void 0:(t=!0,Reflect.apply(e,this,arguments))}},F=e=>e,W=e=>Math.round(1e3*e)/1e3,D=e=>e.charAt(0).toUpperCase()+e.slice(1),H=e=>""!=`${e}`&&void 0!==e;const U=(e,t,n)=>{if(typeof e!==t)throw new TypeError(`${n} is not a ${D(t)}`)};let V=!0;const Z=(J=function(n={}){const c={},u={},p=[],h={...a,expand:!n.collapsed||a.expanded,...n};let g="";function y(){p.length=0,g=""}function b(){delete h.event,y()}const v=()=>!!p.some((([e])=>e in i))||!!h.expand;function z(){if(0!==p.length){l[v()?"group":"groupCollapsed"](`%c${h.label}%c ${(e=>{const t=e.event||e.defaultEvent;return t?`${t}`:""})(h)} %c${h.showTime?g:""}`,e,t,o);for(const[e,...t]of p)l.assert(e in l,`Unknown console method: ${e}`),e in l&&l[e](...t);l.groupEnd(),b()}else b()}function w(){""===g&&(g=function(){const e=new Date,t=(t,n)=>e[t]().toString().padStart(n,"0");return`@ ${t("getHours",2)}:${t("getMinutes",2)}:${t("getSeconds",2)}.${t("getMilliseconds",3)}`}())}function $(e,...t){0===p.length&&(w(),queueMicrotask((()=>queueMicrotask(z)))),p.push([e,...t])}function S(e=r,...t){c[e]?$("log",`${e}: ${performance.now()-c[e]} ms`,...t):$("timeLog",e,...t)}return{...m(h,f(h)),...m(console,(e=>[e,(...t)=>$(e,...t)])),...m(s,d),assert:function(e,...t){e||$("assert",e,...t)},count:function(e=r){u[e]?u[e]+=1:u[e]=1,$("log",`${e}: ${u[e]}`)},countReset:function(e=r){delete u[e]},endAutoGroup:z,errorBoundary:e=>(...t)=>{let n;try{n=e(...t)}catch(e){if(!Error.prototype.isPrototypeOf(e))throw e;$("error",e)}return n},event:function(e){w(),h.event=e},purge:y,time:function(e=r){w(),c[e]=performance.now()},timeEnd:function(e=r){S(e),delete c[e]},timeLog:S,touch:w}},J?.__esModule?J.default:J);var J;const _=Z({label:"iframeResizer(child)"});var Q;const G=(Q="log",(...e)=>!V||_[Q](...e)),{assert:Y,debug:X,endAutoGroup:K,error:ee,errorBoundary:te,event:ne,label:oe,purge:re,warn:ie}=_,ae=e=>{return _.warn((t=F,e=>window.chrome?t(e.replaceAll("<br>","\n").replaceAll("<rb>","[31;1m").replaceAll("</>","[m").replaceAll("<b>","[1m").replaceAll("<i>","[3m").replaceAll("<u>","[4m")):t(e.replaceAll("<br>","\n").replaceAll(/<[/a-z]+>/gi,"")))(e));var t},se=ae,le=(e=>(t,n="renamed to")=>(o,r,i="",a="")=>e(a,`<rb>Deprecated ${t}(${o.replace("()","")})</>\n\nThe <b>${o}</> ${t.toLowerCase()} has been ${n} <b>${r}</>. ${i}Use of the old ${t.toLowerCase()} will be removed in a future version of <i>iframe-resizer</>.`))(((e,t)=>ae(t))),ce=le("Method"),ue=le("Method","replaced with"),de=le("Option"),fe=["min-height","min-width","max-height","max-width"],me=new Set,pe=(e,t)=>window.getComputedStyle(e).getPropertyValue(t),he=(e,t)=>{return(n=pe(e,t))&&"0px"!==n&&"auto"!==n&&"none"!==n;var n};function ge({href:e}){me.has(e)||me.add(e)}const ye=(e,t)=>function(e,t){const n=e.style[t];return n?{source:"an inline style attribute",value:n}:null}(e,t)||function(e,t){for(const n of document.styleSheets)try{for(const o of n.cssRules||[])if(o.selectorText&&e.matches(o.selectorText)){const e=o.style[t];if(e)return{source:"STYLE"===n.ownerNode.tagName?"an inline <style> block":`stylesheet (${n.href})`,value:e}}}catch(e){ge(n)}return{source:"cross-origin stylesheet",value:pe(e,t)}}(e,t),be=(e,t)=>{const{source:n,value:o}=ye(e,t),r=(e=>e.tagName?e.tagName.toLowerCase():"unknown")(e);ae(`The <b>${t}</> CSS property is set to <b>${o}</> on the <b><${r}></> element via ${n}. This may cause issues with the correct operation of <i>iframe-resizer</>.\n\nIf you wish to restrict the size of the iframe, then you should set this property on the iframe element itself, not the content inside it.`)};function ve(){for(const e of[document.documentElement,document.body])for(const t of fe)he(e,t)&&be(e,t)}const ze=e=>t=>void 0===t?void 0:e(t),we=ze((e=>"true"===e)),$e=ze(Number),Se="--ifr-start",Ee="--ifr-end",Oe=[],je=new WeakSet,ke=e=>"object"==typeof e&&je.add(e);let Me={},Te=0;const Ce=setInterval((()=>{if(Oe.length<10)return;if(Me.hasTags&&Me.len<25)return;Oe.sort();const e=Math.min(Oe.reduce(((e,t)=>e+t),0)/Oe.length,Oe[Math.floor(Oe.length/2)]),t=W(e);t>Te&&(Te=t,ne("performanceObserver")),e<=4||(clearInterval(Ce),ae(`<rb>Performance Warning</>\n\nCalculating the page size is taking an excessive amount of time (${W(e)}ms).\n\nTo improve performance add the <b>data-iframe-size</> attribute to the ${Me.Side.toLowerCase()} most element on the page. For more details see: <u>https://iframe-resizer.com/perf</>.`))}),5e3);function xe(e){e.getEntries().forEach((e=>{if(e.name===Ee){const{duration:t}=performance.measure("--ifr-measure",Se,Ee);Me=e.detail,Oe.push(t),Oe.length>100&&Oe.shift()}}))}function Ae(){new PerformanceObserver(xe).observe({entryTypes:["mark"]}),ke(document.documentElement),ke(document.body)}"undefined"!=typeof document&&"undefined"!=typeof PerformanceObserver&&("loading"===document.readyState?document.addEventListener("DOMContentLoaded",Ae):Ae());const Ie=e=>(t,n)=>{if(n in t){if(typeof t[n]===e)return t[n];throw new TypeError(`${n} is not a ${e}.`)}},Pe=Ie("function"),Ne=Ie("number"),Re=Ie("string");"undefined"!=typeof window&&function(){const o={height:()=>(ie("Custom height calculation function not defined"),St.auto()),width:()=>(ie("Custom width calculation function not defined"),Et.auto())},r={bodyOffset:1,bodyScroll:1,offset:1,documentElementOffset:1,documentElementScroll:1,boundingClientRect:1,max:1,min:1,grow:1,lowestElement:1},i={},a="auto",s="[iFrameSizer]",l="scroll";let c,u,d,f,m,p=!0,R="",W=0,Z="",J="",Q=!1,X=!0,ee=!1,le=!0,fe=!1,me=!1,pe=!1,he=1,ge=a,ye="",be=!0,ze={},Oe=!0,je=!1,ke="",Me=0,Te=!1,Ce="",xe=F,Ae=[],Ie="child",Be=null,qe=!1,Le="",Fe=[],We=window.parent,De="*",He=0,Ue=!1,Ve=1,Ze=l,Je=window,_e=()=>{ie("onMessage function not defined")},Qe=()=>{},Ge=null,Ye=null;function Xe(e){var t,n,r;!function(e){Ce=e[0]??Ce,W=$e(e[1])??W,ee=we(e[2])??ee,je=we(e[3])??je,p=we(e[6])??p,Z=e[7]??Z,ge=e[8]??ge,R=e[9]??R,J=e[10]??J,He=$e(e[11])??He,ze.enable=we(e[12])??!1,Ie=e[13]??Ie,Ze=e[14]??Ze,Te=we(e[15])??Te,c=$e(e[16])??c,u=$e(e[17])??u,X=we(e[18])??X,ke=e[19]??ke,f=e[20]??f,Me=$e(e[21])??Me,Oe=we(e[23])??Oe}(e),t={id:Ce,enabled:je,expand:Oe},_.label(`${t.id}`),_.expand(t.expand),V=t.enabled,function(){function e(e){m=Pe(e,"onBeforeResize")??m,_e=Pe(e,"onMessage")??_e,Qe=Pe(e,"onReady")??Qe,"number"==typeof e?.offset&&(de("offset","offsetSize"),X&&(c=Ne(e,"offset")??c),ee&&(u=Ne(e,"offset")??u)),"number"==typeof e?.offsetSize&&(X&&(c=Ne(e,"offsetSize")??c),ee&&(u=Ne(e,"offsetSize")??u)),ye=Re(e,"ignoreSelector")??ye,Le=Re(e,"sizeSelector")??Le,De=Re(e,"targetOrigin")??De,ge=e?.heightCalculationMethod||ge,Ze=e?.widthCalculationMethod||Ze}function t(e,t){return"function"==typeof e&&(ae(`<rb>Deprecated Option(${t}CalculationMethod)</>\n\nThe use of <b>${t}CalculationMethod</> as a function is deprecated and will be removed in a future version of <i>iframe-resizer</>. Please use the new <b>onBeforeResize</> event handler instead.\n\nSee <u>https://iframe-resizer.com/api/child</> for more details.`),o[t]=e,e="custom"),e}if(1===Me)return;const n=window.iframeResizer||window.iFrameResizer;"object"==typeof n&&(e(n),ge=t(ge,"height"),Ze=t(Ze,"width"),G(`Set targetOrigin for parent: %c${De}`,h))}(),lt(),function(){try{qe=1===Me||"iframeParentListener"in window.parent}catch(e){}}(),ee===X&&(Q=!0),Me<0?se(`${B(Me+2)}${B(2)}`):f?.codePointAt(0)>4||Me<2&&se(B(3)),f&&""!==f&&"false"!==f?f!==y&&ae(`<b>Version mismatch</>\n\nThe parent and child pages are running different versions of <i>iframe resizer</>.\n\nParent page: ${f} - Child page: ${y}.\n`):ae("<rb>Legacy version detected on parent page</>\n\nDetected legacy version of parent page script. It is recommended to update the parent page to use <b>@iframe-resizer/parent</>.\n\nSee <u>https://iframe-resizer.com/setup/</> for more details.\n"),dt(),ft(),function(){let e=!1;const t=t=>document.querySelectorAll(`[${t}]`).forEach((n=>{e=!0,n.removeAttribute(t),n.toggleAttribute(v,!0)}));t("data-iframe-height"),t("data-iframe-width"),e&&ae("<rb>Deprecated Attributes</>\n          \nThe <b>data-iframe-height</> and <b>data-iframe-width</> attributes have been deprecated and replaced with the single <b>data-iframe-size</> attribute. Use of the old attributes will be removed in a future version of <i>iframe-resizer</>.")}(),"BackCompat"===document.compatMode&&ae("<rb>Quirks Mode Detected</>\n\nThis iframe is running in the browser's legacy <b>Quirks Mode</>, this may cause issues with the correct operation of <i>iframe-resizer</>. It is recommended that you switch to the modern <b>Standards Mode</>.\n\nFor more information see <u>https://iframe-resizer.com/quirks-mode</>.\n"),nt(),Q||ve(),1!==Me&&(Je.parentIframe=Object.freeze({autoResize:e=>(U(e,"boolean","parentIframe.autoResize(enable) enable"),!1===ee&&!1===X?(ne(E),ae(`Auto Resize can not be changed when <b>direction</> is set to '${I}'.`),!1):(!0===e&&!1===p?(p=!0,queueMicrotask((()=>Tt(E,"Auto Resize enabled")))):!1===e&&!0===p&&(p=!1),xt(0,0,"autoResize",JSON.stringify(p)),p)),close(){xt(0,0,"close")},getId:()=>Ce,getOrigin:()=>(ce("getOrigin()","getParentOrigin()"),d),getParentOrigin:()=>d,getPageInfo(e){if("function"==typeof e)return Ge=e,xt(0,0,"pageInfo"),void ue("getPageInfo()","getParentProps()","See <u>https://iframe-resizer.com/upgrade</> for details. ");Ge=null,xt(0,0,"pageInfoStop")},getParentProps:e=>(U(e,"function","parentIframe.getParentProps(callback) callback"),Ye=e,xt(0,0,"parentInfo"),()=>{Ye=null,xt(0,0,"parentInfoStop")}),getParentProperties(e){ce("getParentProperties()","getParentProps()"),this.getParentProps(e)},moveToAnchor(e){U(e,"string","parentIframe.moveToAnchor(anchor) anchor"),ze.findTarget(e)},reset(){!function(){const e=ge;ge=a,Ue||(Ue=!0,requestAnimationFrame((()=>{Ue=!1}))),Ct("reset"),ge=e}()},setOffsetSize(e){U(e,"number","parentIframe.setOffsetSize(offset) offset"),c=e,u=e,Tt(T,`parentIframe.setOffsetSize(${e})`)},scrollBy(e,t){U(e,"number","parentIframe.scrollBy(x, y) x"),U(t,"number","parentIframe.scrollBy(x, y) y"),xt(t,e,"scrollBy")},scrollTo(e,t){U(e,"number","parentIframe.scrollTo(x, y) x"),U(t,"number","parentIframe.scrollTo(x, y) y"),xt(t,e,"scrollTo")},scrollToOffset(e,t){U(e,"number","parentIframe.scrollToOffset(x, y) x"),U(t,"number","parentIframe.scrollToOffset(x, y) y"),xt(t,e,"scrollToOffset")},sendMessage(e,t){t&&U(t,"string","parentIframe.sendMessage(msg, targetOrigin) targetOrigin"),xt(0,0,"message",JSON.stringify(e),t)},setHeightCalculationMethod(e){ge=e,dt()},setWidthCalculationMethod(e){Ze=e,ft()},setTargetOrigin(e){U(e,"string","parentIframe.setTargetOrigin(targetOrigin) targetOrigin"),De=e},resize(e,t){e&&U(e,"number","parentIframe.resize(customHeight, customWidth) customHeight"),t&&U(t,"number","parentIframe.resize(customHeight, customWidth) customWidth"),Tt(j,`parentIframe.resize(${e||""}${t?`,${t}`:""})`,e,t)},size(e,t){ce("size()","resize()"),this.resize(e,t)}}),Je.parentIFrame=Je.parentIframe),function(){function e(e){xt(0,0,e.type,`${e.screenY}:${e.screenX}`)}function t(t,n){N(window.document,t,e)}!0===Te&&(t("mouseenter"),t("mouseleave"))}(),ze=function(){const e=()=>({x:document.documentElement.scrollLeft,y:document.documentElement.scrollTop});function t(t){const n=t.getBoundingClientRect(),o=e();return{x:parseInt(n.left,b)+parseInt(o.x,b),y:parseInt(n.top,b)+parseInt(o.y,b)}}function n(e){function n(e){const n=t(e);xt(n.y,n.x,"scrollToOffset")}const o=e.split("#")[1]||e,r=decodeURIComponent(o),i=document.getElementById(r)||document.getElementsByName(r)[0];void 0===i?xt(0,0,"inPageLink",`#${o}`):n(i)}function o(){const{hash:e,href:t}=window.location;""!==e&&"#"!==e&&n(t)}function r(){for(const e of document.querySelectorAll('a[href^="#"]'))"#"!==e.getAttribute("href")&&N(e,"click",(t=>{t.preventDefault(),n(e.getAttribute("href"))}))}function i(){N(window,"hashchange",o)}function a(){setTimeout(o,128)}function s(){r(),i(),a()}return ze.enable&&(1===Me?ae("In page linking requires a Professional or Business license. Please see <u>https://iframe-resizer.com/pricing</> for more details."):s()),{findTarget:n}}(),void 0===Z&&(Z=`${W}px`),at("margin",(n="margin",(r=Z).includes("-")&&(ie(`Negative CSS value ignored for ${n}`),r=""),r)),at("background",R),at("padding",J),function(){const e=document.createElement("div");e.style.clear="both",e.style.display="block",e.style.height="0",document.body.append(e)}(),Q||function(){const e=e=>e.style.setProperty("height","auto","important");e(document.documentElement),e(document.body)}(),function(e){ct({method:e,eventType:"After Print",eventName:"afterprint"}),ct({method:e,eventType:"Before Print",eventName:"beforeprint"}),ct({method:e,eventType:"Ready State Change",eventName:"readystatechange"})}("add"),function(){const e=new Set,t=[];let n=!1,o=0;const r=t=>{G("Mutations observed:",t);for(const n of t){const{addedNodes:t,removedNodes:o}=n;for(const n of t)e.add(n);for(const t of o)e.delete(t)}},i=16,a=2,s=200;let l=1;function c(e){lt(),ot(e),e.forEach(ht),e.clear()}function u(){const d=performance.now(),f=d-o;if(f>i*l+++a&&f<s)return G("Backed off due to heavy workload on callStack"),setTimeout(u,i*l),void(o=d);l=1,t.forEach(r),t.length=0,e.size>0&&c(e),nt(),et(),n=!1,Tt(A,"Mutation Observed")}function d(e){t.push(e),n||(o=performance.now(),n=!0,requestAnimationFrame(u))}function f(){const e=new window.MutationObserver(d),t=document.querySelector("body"),n={attributes:!0,attributeFilter:[w,v],attributeOldValue:!1,characterData:!1,characterDataOldValue:!1,childList:!0,subtree:!0};return e.observe(t,n),e}f()}(),Be=new ResizeObserver(mt),Be.observe(document.body),pt.add(document.body),ht(document.body),X!==ee&&(xe=(e=>{const t=e.side||$,n=e.onChange||F,o={root:e.root,rootMargin:"0px",threshold:1},r=window?.requestAnimationFrame||F,i=(e=!1)=>n(e),a=(e,n)=>0===e||e>n[t],s=(e,t)=>e.toggleAttribute(z,t),l=new IntersectionObserver((function(e){for(const o of e){const{boundingClientRect:e,rootBounds:r,target:i}=o,l=e[t],c=a(l,r)&&!((n=i).hidden||null===n.offsetParent||"none"===n.style.display);s(i,c)}var n;r(i)}),o),c=new WeakSet;return function(e){for(const t of e){const e=t.nodeType===Node.ELEMENT_NODE,n=c.has(t);!n&&e?(l.observe(t),c.add(t)):Y(!n,"Node already observed",t)}}})({onChange:tt,root:document.documentElement,side:X?$:S})),ot(bt(document)()),Ke(L(Qe)),Tt(P,"Init message from host page",void 0,void 0,y),document.title&&""!==document.title&&xt(0,0,"title",document.title)}function Ke(e){"complete"===document.readyState?q(e):N(document,"readystatechange",(()=>Ke(e)))}function et(){const e=document.querySelectorAll(`[${z}]`);Ae=Array.from(e).filter((e=>!e.closest(`[${w}]`))),me=Ae.length>0}function tt(e){et(),(me||e)&&(me?G("Overflowed Elements:",...Ae):G("Overflow removed"),Tt(x,"Overflow updated"))}function nt(){Fe=document.querySelectorAll(`[${v}]`),pe=Fe.length>0}function ot(e){pe||xe(e)}let rt=0;function it(){const n=document.querySelectorAll(`*[${w}]`);fe=n.length>0,fe&&n.length!==rt&&(function(n){const o=1===n.length?"":"s";ie(`%c[${w}]%c found on %c${n.length}%c element${o}`,t,e,t,e)}(n),rt=n.length)}function at(e,t){void 0!==t&&""!==t&&"null"!==t&&(document.body.style.setProperty(e,t),G(`Set body ${e}: %c${t}`,h))}function st(e,t,n){if(""!==n)for(const e of document.querySelectorAll(n))e.toggleAttribute(t,!0)}function lt(){st(0,v,Le),st(0,w,ye)}function ct(e){({add(t){function n(){Tt(e.eventName,e.eventType)}i[t]=n,N(window,t,n,{passive:!0})},remove(e){const t=i[e];var n,o;delete i[e],n=e,o=t,window.removeEventListener(n,o,!1)}})[e.method](e.eventName)}function ut(e,t,n,o){return t!==e&&(e in n||(ie(`${e} is not a valid option for ${o}CalculationMethod.`),e=t),e in r)&&ae(`<rb>Deprecated ${o}CalculationMethod (${e})</>\n\nThis version of <i>iframe-resizer</> can auto detect the most suitable ${o} calculation method. It is recommended that you ${f?"remove this option.":"set this option to <b>'auto'</> when using an older version of <i>iframe-resizer</> on the parent page."}`),e}function dt(){ge=ut(ge,a,St,"height")}function ft(){Ze=ut(Ze,l,Et,"width")}function mt(e){if(!Array.isArray(e)||0===e.length)return;const t=e[0].target;Tt(C,`Element resized <${function(e){switch(!0){case!H(e):return"";case H(e.id):return`${e.nodeName}#${e.id}`;case H(e.name):return`${e.nodeName} (${e.name}`;case H(e.className):return`${e.nodeName}.${e.className}`;default:return e.nodeName}}(t)}>`)}const pt=new WeakSet;function ht(e){if(e.nodeType!==Node.ELEMENT_NODE)return;if(!pt.has(e)){const t=getComputedStyle(e)?.position;""!==t&&"static"!==t&&(Be.observe(e),pt.add(e))}const t=bt(e)();for(const e of t){if(pt.has(e)||e?.nodeType!==Node.ELEMENT_NODE)continue;const t=getComputedStyle(e)?.position;""!==t&&"static"!==t&&(Be.observe(e),pt.add(e))}}function gt(e){performance.mark(Se);const t=D(e);let n=0,o=document.documentElement,r=pe?0:document.documentElement.getBoundingClientRect().bottom;const i=pe?Fe:me?Ae:bt(document)();for(const t of i)n=t.getBoundingClientRect()[e]+parseFloat(getComputedStyle(t).getPropertyValue(`margin-${e}`)),n>r&&(r=n,o=t);return G(`${t} position calculated from:`,o),performance.mark(Ee,{detail:{hasTags:pe,len:i.length,logging:je,Side:t}}),r}const yt=e=>[e.bodyOffset(),e.bodyScroll(),e.documentElementOffset(),e.documentElementScroll(),e.boundingClientRect()],bt=e=>()=>{it();const t=["* ","not(head)","not(meta)","not(base)","not(title)","not(script)","not(link)","not(style)","not(map)","not(area)","not(option)","not(optgroup)","not(template)","not(track)","not(wbr)","not(nobr)"];return fe&&t.push(`not([${w}])`,`not([${w}] *)`),e.querySelectorAll(t.join(":"))},vt={height:0,width:0},zt={height:0,width:0},wt=[h,g,h];function $t(e){function t(){return zt[o]=r,vt[o]=s,r}const n=e===St,o=n?"height":"width",r=e.boundingClientRect(),i=Math.ceil(r),a=Math.floor(r),s=(e=>e.documentElementScroll()+Math.max(0,e.getOffset()))(e),l=`HTML: %c${r}px %cPage: %c${s}px`;let c=0;switch(!0){case!e.enabled():return s;case pe:G("Found element with data-iframe-size attribute"),c=e.taggedElement();break;case!me&&0===zt[o]&&0===vt[o]:G(`Initial page size values: ${l}`,...wt),c=t();break;case Ue&&r===zt[o]&&s===vt[o]:G(`Size unchanged: ${l}`,...wt),c=Math.max(r,s);break;case 0===r:G(`Page is hidden: ${l}`,...wt),c=s;break;case!me&&r!==zt[o]&&s<=vt[o]:G(`New <html> size: ${l} `,...wt),G(`Previous <html> size: %c${zt[o]}px`,h),c=t();break;case!n:c=e.taggedElement();break;case!me&&r<zt[o]:G(`<html> size decreased: ${l}`,...wt),c=t();break;case s===a||s===i:G(`<html> size equals page size: ${l}`,...wt),c=t();break;case r>s:G(`Page size < <html> size: ${l}`,...wt),c=t();break;case me:G("Found element overflowing <html> "),c=e.taggedElement();break;default:G(`Using <html> size: ${l}`,...wt),c=t()}return G(`Content ${o}: %c${c}px`,h),c+=function(e){const t=e.getOffset();return 0!==t&&G(`Page offsetSize: %c${t}px`,h),t}(e),c}const St={enabled:()=>X,getOffset:()=>c,auto:()=>$t(St),bodyOffset:()=>{const{body:e}=document,t=getComputedStyle(e);return e.offsetHeight+parseInt(t.marginTop,b)+parseInt(t.marginBottom,b)},bodyScroll:()=>document.body.scrollHeight,offset:()=>St.bodyOffset(),custom:()=>o.height(),documentElementOffset:()=>document.documentElement.offsetHeight,documentElementScroll:()=>document.documentElement.scrollHeight,boundingClientRect:()=>Math.max(document.documentElement.getBoundingClientRect().bottom,document.body.getBoundingClientRect().bottom),max:()=>Math.max(...yt(St)),min:()=>Math.min(...yt(St)),grow:()=>St.max(),lowestElement:()=>gt($),taggedElement:()=>gt($)},Et={enabled:()=>ee,getOffset:()=>u,auto:()=>$t(Et),bodyScroll:()=>document.body.scrollWidth,bodyOffset:()=>document.body.offsetWidth,custom:()=>o.width(),documentElementScroll:()=>document.documentElement.scrollWidth,documentElementOffset:()=>document.documentElement.offsetWidth,boundingClientRect:()=>Math.max(document.documentElement.getBoundingClientRect().right,document.body.getBoundingClientRect().right),max:()=>Math.max(...yt(Et)),min:()=>Math.min(...yt(Et)),rightMostElement:()=>gt(S),scroll:()=>Math.max(Et.bodyScroll(),Et.documentElementScroll()),taggedElement:()=>gt(S)},Ot=(e,t)=>!(Math.abs(e-t)<=He);function jt(e,t){const n=e[t]();return e.enabled()&&void 0!==m?function(e){const t=m(e);if(void 0===t)throw new TypeError("No value returned from onBeforeResize(), expected a numeric value");if(Number.isNaN(t))throw new TypeError(`Invalid value returned from onBeforeResize(): ${t}, expected Number`);return t}(n):n}let kt=!1;const Mt=L((()=>se(B(4)))),Tt=te(((e,t,n,o,r)=>{if(performance.now(),ne(e),!0!==kt)return p||e in M?void(document.hidden||(kt=!0,requestAnimationFrame((()=>{kt=!1})),function(e,t,n,o,r){const i=n??jt(St,ge),a=o??jt(Et,Ze);switch(X&&Ot(he,i)||ee&&Ot(Ve,a)?O:e){case P:case E:case O:he=i,Ve=a;case T:xt(he,Ve,e,r);break;case C:case x:case A:re();break;default:re(),G("No change in content size detected")}}(e,0,n,o,r))):(G("Resizing disabled"),void K())}));function Ct(e){he=St[ge](),Ve=Et[Ze](),xt(he,Ve,e)}const xt=te((function(e,t,o,r,i){Me<-1||(ne(o),void 0!==i||(i=De),function(){const a=`${Ce}:${e}:${t}:${o}${void 0===r?"":`:${r}`}`;if(qe)try{window.parent.iframeParentListener(s+a)}catch(e){if(1!==Me)throw e;return void Mt()}else We.postMessage(s+a,i);G(`Sending message to parent page via ${qe?"sameOrigin":"postMessage"}: %c%c${a}`,n,h)}(),K())})),At=te((function(e){ne("onMessage");const{freeze:t}=Object,{parse:n}=JSON,o=e=>xt(0,0,`${e}Stop`),r={init:function(){if("loading"===document.readyState)return;const t=e.data.slice(13).split(":");We=e.source,d=e.origin,Xe(t),le=!1,setTimeout((()=>{be=!1}),128)},reset(){be||Ct("resetPage")},resize(){Tt(k,"Parent window requested size check")},moveToAnchor(){ze.findTarget(a())},inPageLink(){this.moveToAnchor()},pageInfo(){const e=a();Ge?q(Ge,n(e)):o("pageInfo")},parentInfo(){const e=(r=a(),t(n(r)));var r;Ye?q(Ye,e):o("parentInfo")},message(){const e=a();q(_e,n(e))}},i=()=>e.data.split("]")[1].split(":")[0],a=()=>e.data.slice(e.data.indexOf(":")+1),l=()=>e.data.split(":")[2]in{true:1,false:1};function c(){const t=i();ne(t),t in r?r[t]():"iframeResize"in window||void 0!==window.jQuery&&""in window.jQuery.prototype||l()||ie(`Unexpected message (${e.data})`)}s===`${e.data}`.slice(0,13)&&function(){if(!1!==le)return l()?(oe(i()),ne(P),void r.init()):void 0;c()}()}));function It(){"loading"!==document.readyState&&window.parent.postMessage("[iFrameResizerChild]Ready","*")}"iframeChildListener"in window?ie("Already setup"):(window.iframeChildListener=e=>setTimeout((()=>At({data:e,sameOrigin:!0}))),N(window,"message",At),N(window,"readystatechange",It),It())}()}));
